package org.codehaus.mojo.openjpa;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on openjpa-maven-plugin.<br/> Call <pre>  mvn openjpa:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Mon Nov 29 18:12:57 CET 2010
 * @author org.apache.maven.tools.plugin.generator.PluginHelpGenerator (version 2.6)
 * @goal help
 * @requiresProject false
 */
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line, should be positive.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level, should be positive.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        if ( lineLength <= 0 )
        {
            getLog().warn( "The parameter 'lineLength' should be positive, using '80' as default." );
            lineLength = 80;
        }
        if ( indentSize <= 0 )
        {
            getLog().warn( "The parameter 'indentSize' should be positive, using '2' as default." );
            indentSize = 2;
        }

        StringBuffer sb = new StringBuffer();

        append( sb, "org.codehaus.mojo:openjpa-maven-plugin:1.2", 0 );
        append( sb, "", 0 );

        append( sb, "OpenJPA Maven Plugin", 0 );
        append( sb, "OpenJPA (http://openjpa.apache.org) tasks for enhancing, SQL creation and schema mapping creation", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 5 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "enhance".equals( goal ) )
        {
            append( sb, "openjpa:enhance", 0 );
            append( sb, "Processes Application model classes and enhances them by running Open JPA Enhancer tool. This basically only acts as a container for the xdoclet stuff since all the required functionality is already in the AbstratOpenJpaEnhancerMojo.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "addDefaultConstructor (Default: true)", 2 );
                append( sb, "The JPA spec requires that all persistent classes define a no-arg constructor. This flag tells the enhancer whether to add a protected no-arg constructor to any persistent classes that don\'t already have one.", 3 );
                append( sb, "", 0 );

                append( sb, "classes (Default: ${project.build.outputDirectory})", 2 );
                append( sb, "Location where persistence-enabled classes are located.", 3 );
                append( sb, "", 0 );

                append( sb, "connectionDriverName", 2 );
                append( sb, "This setting can be used to override any openjpa.ConnectionDriverName set in the persistence.xml. It can also be used if the persistence.xml contains no connection information at all.\n\nSample:\n\n<connectionDriverName>com.mchange.v2.c3p0.ComboPooledDataSource</connectionDriverName>\nThis is most times used in conjunction with connectionProperties.", 3 );
                append( sb, "", 0 );

                append( sb, "connectionProperties", 2 );
                append( sb, "Used to define the credentials or any other connection properties.\nSample:\n<connectionProperties>\n\u00a0\u00a0driverClass=com.mysql.jdbc.Driver,\n\u00a0\u00a0jdbcUrl=jdbc:mysql://localhost/mydatabase,\n\u00a0\u00a0user=root,\n\u00a0\u00a0password=,\n\u00a0\u00a0minPoolSize=5,\n\u00a0\u00a0acquireRetryAttempts=3,\n\u00a0\u00a0maxPoolSize=20\n</connectionProperties>\nThis is most times used in conjunction with connectionDriverName.", 3 );
                append( sb, "", 0 );

                append( sb, "enforcePropertyRestrictions (Default: false)", 2 );
                append( sb, "Whether to throw an exception when it appears that a property access entity is not obeying the restrictions placed on property access.", 3 );
                append( sb, "", 0 );

                append( sb, "excludes", 2 );
                append( sb, "Comma separated list of excludes to scan searchDir to pass to the jobs. This option may be used to stop OpenJPA tasks from scanning non-JPA classes (which usually leads to warnings such as \'Type xxx has no metadata\')", 3 );
                append( sb, "", 0 );

                append( sb, "forceMojoExecution (Default: false)", 2 );
                append( sb, "Setting this parameter to true will force the execution of this mojo, even if it would get skipped usually.", 3 );
                append( sb, "", 0 );

                append( sb, "includes (Default: **/*.class)", 2 );
                append( sb, "Comma separated list of includes to scan searchDir to pass to the jobs. This may be used to restrict the OpenJPA tasks to e.g. a single package which contains all the entities.", 3 );
                append( sb, "", 0 );

                append( sb, "persistenceXmlFile", 2 );
                append( sb, "Used if a non-default file location for the persistence.xml should be used If not specified, the default one in META-INF/persistence.xml will be used. Please note that this is not a resource location but a file path!", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "When true, skip the execution.", 3 );
                append( sb, "", 0 );

                append( sb, "tmpClassLoader (Default: false)", 2 );
                append( sb, "Tell the PCEnhancer to use a temporary classloader for enhancement. If you enable this feature, then no depending artifacts from the classpath will be used! Please note that you have to disable the tmpClassLoader for some cases in OpenJPA-1.2.1 due to an extended parsing strategy.", 3 );
                append( sb, "", 0 );

                append( sb, "toolProperties", 2 );
                append( sb, "Additional properties passed to the OpenJPA tools.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "openjpa:help", 0 );
            append( sb, "Display help information on openjpa-maven-plugin.\nCall\n\u00a0\u00a0mvn\u00a0openjpa:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level, should be positive.", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line, should be positive.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "schema".equals( goal ) )
        {
            append( sb, "openjpa:schema", 0 );
            append( sb, "Executes the schema generation via the OpenJPA MappingTool.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "action", 2 );
                append( sb, "Argument to specify the action to take on each class. The available actions are: buildSchema, validate", 3 );
                append( sb, "", 0 );

                append( sb, "classes (Default: ${project.build.outputDirectory})", 2 );
                append( sb, "Location where persistence-enabled classes are located.", 3 );
                append( sb, "", 0 );

                append( sb, "connectionDriverName", 2 );
                append( sb, "This setting can be used to override any openjpa.ConnectionDriverName set in the persistence.xml. It can also be used if the persistence.xml contains no connection information at all.\n\nSample:\n\n<connectionDriverName>com.mchange.v2.c3p0.ComboPooledDataSource</connectionDriverName>\nThis is most times used in conjunction with connectionProperties.", 3 );
                append( sb, "", 0 );

                append( sb, "connectionProperties", 2 );
                append( sb, "Used to define the credentials or any other connection properties.\nSample:\n<connectionProperties>\n\u00a0\u00a0driverClass=com.mysql.jdbc.Driver,\n\u00a0\u00a0jdbcUrl=jdbc:mysql://localhost/mydatabase,\n\u00a0\u00a0user=root,\n\u00a0\u00a0password=,\n\u00a0\u00a0minPoolSize=5,\n\u00a0\u00a0acquireRetryAttempts=3,\n\u00a0\u00a0maxPoolSize=20\n</connectionProperties>\nThis is most times used in conjunction with connectionDriverName.", 3 );
                append( sb, "", 0 );

                append( sb, "excludes", 2 );
                append( sb, "Comma separated list of excludes to scan searchDir to pass to the jobs. This option may be used to stop OpenJPA tasks from scanning non-JPA classes (which usually leads to warnings such as \'Type xxx has no metadata\')", 3 );
                append( sb, "", 0 );

                append( sb, "forceMojoExecution (Default: false)", 2 );
                append( sb, "Setting this parameter to true will force the execution of this mojo, even if it would get skipped usually.", 3 );
                append( sb, "", 0 );

                append( sb, "includes (Default: **/*.class)", 2 );
                append( sb, "Comma separated list of includes to scan searchDir to pass to the jobs. This may be used to restrict the OpenJPA tasks to e.g. a single package which contains all the entities.", 3 );
                append( sb, "", 0 );

                append( sb, "persistenceXmlFile", 2 );
                append( sb, "Used if a non-default file location for the persistence.xml should be used If not specified, the default one in META-INF/persistence.xml will be used. Please note that this is not a resource location but a file path!", 3 );
                append( sb, "", 0 );

                append( sb, "schemaAction (Default: add)", 2 );
                append( sb, "The action to take on the schema. Actions can be composed in a comma-separated list of one of the following items:\n-\tadd (see MappingTool#ACTION_ADD)\n-\trefresh (see MappingTool#ACTION_REFRESH)\n-\tdrop (see MappingTool#ACTION_DROP)\n-\tbuildSchema (see MappingTool#ACTION_BUILD_SCHEMA)\n-\timport (see MappingTool#ACTION_IMPORT)\n-\texport (see MappingTool#ACTION_EXPORT)\n-\tvalidate (see MappingTool#ACTION_VALIDATE)\n", 3 );
                append( sb, "", 0 );

                append( sb, "schemaFile (Default: ${project.build.directory}/schema.xml)", 2 );
                append( sb, "Use this option to write the planned schema to an XML document rather than modify the database. The document can then be manipulated and committed to the database with the schema tool", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "When true, skip the execution.", 3 );
                append( sb, "", 0 );

                append( sb, "toolProperties", 2 );
                append( sb, "Additional properties passed to the OpenJPA tools.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "sql".equals( goal ) )
        {
            append( sb, "openjpa:sql", 0 );
            append( sb, "Executes the SQL generation via the OpenJPA MappingTool.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "action", 2 );
                append( sb, "Argument to specify the action to take on each class. The available actions are: buildSchema, validate", 3 );
                append( sb, "", 0 );

                append( sb, "classes (Default: ${project.build.outputDirectory})", 2 );
                append( sb, "Location where persistence-enabled classes are located.", 3 );
                append( sb, "", 0 );

                append( sb, "connectionDriverName", 2 );
                append( sb, "This setting can be used to override any openjpa.ConnectionDriverName set in the persistence.xml. It can also be used if the persistence.xml contains no connection information at all.\n\nSample:\n\n<connectionDriverName>com.mchange.v2.c3p0.ComboPooledDataSource</connectionDriverName>\nThis is most times used in conjunction with connectionProperties.", 3 );
                append( sb, "", 0 );

                append( sb, "connectionProperties", 2 );
                append( sb, "Used to define the credentials or any other connection properties.\nSample:\n<connectionProperties>\n\u00a0\u00a0driverClass=com.mysql.jdbc.Driver,\n\u00a0\u00a0jdbcUrl=jdbc:mysql://localhost/mydatabase,\n\u00a0\u00a0user=root,\n\u00a0\u00a0password=,\n\u00a0\u00a0minPoolSize=5,\n\u00a0\u00a0acquireRetryAttempts=3,\n\u00a0\u00a0maxPoolSize=20\n</connectionProperties>\nThis is most times used in conjunction with connectionDriverName.", 3 );
                append( sb, "", 0 );

                append( sb, "excludes", 2 );
                append( sb, "Comma separated list of excludes to scan searchDir to pass to the jobs. This option may be used to stop OpenJPA tasks from scanning non-JPA classes (which usually leads to warnings such as \'Type xxx has no metadata\')", 3 );
                append( sb, "", 0 );

                append( sb, "forceMojoExecution (Default: false)", 2 );
                append( sb, "Setting this parameter to true will force the execution of this mojo, even if it would get skipped usually.", 3 );
                append( sb, "", 0 );

                append( sb, "includes (Default: **/*.class)", 2 );
                append( sb, "Comma separated list of includes to scan searchDir to pass to the jobs. This may be used to restrict the OpenJPA tasks to e.g. a single package which contains all the entities.", 3 );
                append( sb, "", 0 );

                append( sb, "modifyDatabase (Default: false)", 2 );
                append( sb, "Use this option to write the planned schema modifications to the database. If this is set, the sqlFile setting (if any) will be ignored.", 3 );
                append( sb, "", 0 );

                append( sb, "persistenceXmlFile", 2 );
                append( sb, "Used if a non-default file location for the persistence.xml should be used If not specified, the default one in META-INF/persistence.xml will be used. Please note that this is not a resource location but a file path!", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "When true, skip the execution.", 3 );
                append( sb, "", 0 );

                append( sb, "sqlAction (Default: build)", 2 );
                append( sb, "The action to take for generating the SQL. Actions can be composed in a comma-separated list of one of the following items:\n-\tadd (see MappingTool#ACTION_ADD)\n-\trefresh (see MappingTool#ACTION_REFRESH)\n-\tdrop (see MappingTool#ACTION_DROP)\n-\tbuildSchema (see MappingTool#ACTION_BUILD_SCHEMA)\n-\timport (see MappingTool#ACTION_IMPORT)\n-\texport (see MappingTool#ACTION_EXPORT)\n-\tvalidate (see MappingTool#ACTION_VALIDATE)\nTechnically this is the same like the schemaAction, but we have to split it for the plugin to allow different actions for generating the mapping and generating the SQL files.", 3 );
                append( sb, "", 0 );

                append( sb, "sqlFile (Default: ${project.build.directory}/database.sql)", 2 );
                append( sb, "Use this option to write the planned schema modifications to a SQL script. Combine this with a schemaAction of \'build\' to generate a script that recreates the schema for the current mappings, even if the schema already exists.", 3 );
                append( sb, "", 0 );

                append( sb, "toolProperties", 2 );
                append( sb, "Additional properties passed to the OpenJPA tools.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "test-enhance".equals( goal ) )
        {
            append( sb, "openjpa:test-enhance", 0 );
            append( sb, "Processes Application model classes and enhances them by running Open JPA Enhancer tool.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "addDefaultConstructor (Default: true)", 2 );
                append( sb, "The JPA spec requires that all persistent classes define a no-arg constructor. This flag tells the enhancer whether to add a protected no-arg constructor to any persistent classes that don\'t already have one.", 3 );
                append( sb, "", 0 );

                append( sb, "classes (Default: ${project.build.outputDirectory})", 2 );
                append( sb, "Location where persistence-enabled classes are located.", 3 );
                append( sb, "", 0 );

                append( sb, "connectionDriverName", 2 );
                append( sb, "This setting can be used to override any openjpa.ConnectionDriverName set in the persistence.xml. It can also be used if the persistence.xml contains no connection information at all.\n\nSample:\n\n<connectionDriverName>com.mchange.v2.c3p0.ComboPooledDataSource</connectionDriverName>\nThis is most times used in conjunction with connectionProperties.", 3 );
                append( sb, "", 0 );

                append( sb, "connectionProperties", 2 );
                append( sb, "Used to define the credentials or any other connection properties.\nSample:\n<connectionProperties>\n\u00a0\u00a0driverClass=com.mysql.jdbc.Driver,\n\u00a0\u00a0jdbcUrl=jdbc:mysql://localhost/mydatabase,\n\u00a0\u00a0user=root,\n\u00a0\u00a0password=,\n\u00a0\u00a0minPoolSize=5,\n\u00a0\u00a0acquireRetryAttempts=3,\n\u00a0\u00a0maxPoolSize=20\n</connectionProperties>\nThis is most times used in conjunction with connectionDriverName.", 3 );
                append( sb, "", 0 );

                append( sb, "enforcePropertyRestrictions (Default: false)", 2 );
                append( sb, "Whether to throw an exception when it appears that a property access entity is not obeying the restrictions placed on property access.", 3 );
                append( sb, "", 0 );

                append( sb, "excludes", 2 );
                append( sb, "Comma separated list of excludes to scan searchDir to pass to the jobs. This option may be used to stop OpenJPA tasks from scanning non-JPA classes (which usually leads to warnings such as \'Type xxx has no metadata\')", 3 );
                append( sb, "", 0 );

                append( sb, "forceMojoExecution (Default: false)", 2 );
                append( sb, "Setting this parameter to true will force the execution of this mojo, even if it would get skipped usually.", 3 );
                append( sb, "", 0 );

                append( sb, "includes (Default: **/*.class)", 2 );
                append( sb, "Comma separated list of includes to scan searchDir to pass to the jobs. This may be used to restrict the OpenJPA tasks to e.g. a single package which contains all the entities.", 3 );
                append( sb, "", 0 );

                append( sb, "persistenceXmlFile", 2 );
                append( sb, "Used if a non-default file location for the persistence.xml should be used If not specified, the default one in META-INF/persistence.xml will be used. Please note that this is not a resource location but a file path!", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "When true, skip the execution.", 3 );
                append( sb, "", 0 );

                append( sb, "tmpClassLoader (Default: false)", 2 );
                append( sb, "Tell the PCEnhancer to use a temporary classloader for enhancement. If you enable this feature, then no depending artifacts from the classpath will be used! Please note that you have to disable the tmpClassLoader for some cases in OpenJPA-1.2.1 due to an extended parsing strategy.", 3 );
                append( sb, "", 0 );

                append( sb, "toolProperties", 2 );
                append( sb, "Additional properties passed to the OpenJPA tools.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    /** 
     * Append a description to the buffer by respecting the indentSize and lineLength parameters.
     * <b>Note</b>: The last character is always a new line.
     * 
     * @param sb The buffer to append the description, not <code>null</code>.
     * @param description The description, not <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     */
    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent, indentSize, lineLength ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     * @throws NegativeArraySizeException if <code>indent < 0</code>
     */
    private static List toLines( String text, int indent, int indentSize, int lineLength )
    {
        List lines = new ArrayList();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i], indentSize, lineLength );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     */
    private static void toLines( List lines, String line, int indentSize, int lineLength )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
